package tests;

import static org.junit.Assert.*;

import java.util.List;
import java.util.ArrayList;

import numericalStatistics.Statistics;

import org.junit.*;

/**
 * This  class is responsible for testing the Statistics class.  Requires JUnit 4.
 * 
 * @version 1.0
 * @author hornick
 */

public class StatsTester {
	private final double delta = 1.0E-10; // a "tolerance" constant used for near-equality comparisons of double values

	// 1st data set to be used in the tests; declared here and initialized in the constructor
	private List<Double> testData1 = new ArrayList<Double>(); 
	private double expectedSum1, expectedAverage1, expectedMedian1, expectedMaximum1;

// TODO: declare 2nd, 3rd, 4th, ... additional sets of testData here
//	private  List<Double> testData2 = new ArrayList<Double>(); // 2nd data set to be used in the tests (see constructor below)
//	private  double expectedSum2, expectedAverage2, expectedMedian2, expectedMaximum2;
//  etc

	// This constructor is called once for each @Test, before the setUp() method is called
	public StatsTester() {
		// Values for 1st test suite; an array is used to define the values just because it's convenient...
		Double[] testValues = new Double[]{ 0.0, 1.0, 2.0, 3.0, 4.0 };
		// ...and then we copy the values from the array to the collection
		for( double d: testValues ) {
			testData1.add(d);
		}
		// TODO: initialize CORRECT expected values for avg, mean, median, max
		expectedSum1 = expectedAverage1 = expectedMedian1 = expectedMaximum1 = 0.0;

		// TODO: use the example initialization code above to define additional testData sets
		// and additional expected value sets
		// 2nd test suite data: { -2.0, -1.0, 1.0, 2.0 } 
		// 3rd test suite data: { -3.0, -2.0, -1.0 }
		// 4th test suite data: (empty set): {}
		// 5th test suite data: null set
		// 6th, 7th, etc test suites: others you decide may be needed

		System.out.println("StatsTester class constructed...");
	}

	//Note: You don't have to modify any of the following 4 methods for this assignment.
	
	@BeforeClass
	// This method is called only once at the beginning, each time JUnit is run.
	public static void setUpBeforeClass() throws Exception {
		System.out.println("setUpBeforeClass: Preparing to run unit tests...\n");
	}

	@AfterClass
	// This method is called only once at the end, each time JUnit is run.
	public static void tearDownAfterClass() throws Exception {
		System.out.println("tearDownAfterClass:Exiting unit tests...\n");
	}

	@Before
	// This method is called right before each individual @Test method,
	// but AFTER the class constructor is called.
	public void setUp() throws Exception {
		System.out.println("setUp:Starting a test");
	}

	@After
	// This method is called right after each individual @Test method.
	public void tearDown() throws Exception {
		System.out.println("tearDown:Test complete");
	}
	
//*********************** 1st test suite ****************************************
	@Test
	// This tests the computeSum method for the first test data set
	// @author: <your name>
	public void testSum1()
	{
		// TODO: initialize CORRECT expected value for expectedSum1 in the StatsTester constructor above.
		Statistics s = new Statistics(testData1);
		double x = s.computeSum(); 
		assertEquals( expectedSum1, x, delta ); // see http://junit.sourceforge.net/javadoc/org/junit/Assert.html
	}
	@Test
	// This tests the computeAverage method for the first test data set
	// @author: <your name>
	public void testAverage1()
	{
		// TODO: complete this test method
		fail("testAverage1 not implemented"); // force test to fail until it has been written
	}
	@Test
	// This tests the computeMedian method for the first test data set
	// @author: <your name>
	public void testMedian1()
	{
		// TODO: complete this test method
		fail("testMedian1 not implemented"); // force test to fail until it has been written
	}
	@Test
	// This tests the computeMaximum method for the first test data set
	// @author: <your name>
	public void testMaximum1()
	{
		// TODO: complete this test method
		fail("testMaximum1 not implemented"); // force test to fail until it has been written
	}
	
	@Test
	// This tests the constructor method for the first test data set
	// @author: <your name>
	public void testConstructor() 
	{
		//TODO: Write test methods for the constructor method to make sure it does or does not
		// throw exceptions as appropriate
		// This test can be written multiple ways, such as the try/catch idiom demonstrated in lecture.
		// Alternatively, you may want to investigate the ExpectedException rule
		// described in https://github.com/junit-team/junit/wiki/Exception-testing
		fail("testConstructor not implemented"); // force test to fail until it has been written		
	}
	
//*********************** end 1st test suite ****************************************

// TODO: add test suites for 2nd, 3rd, etc data sets

}
